package com.steerinfo.ems.emsgmpcjh.controller;

import com.steerinfo.auth.utils.JwtUtil;
import com.steerinfo.ems.Utils.DateUtils;
import com.steerinfo.ems.emsgmpcjh.mapper.EmsGmPcJhMapper;
import com.steerinfo.ems.emsgmpcjh.model.EmsGmPcJh;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.ems.emsgmpcjh.service.IEmsGmPcJhService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.rmi.MarshalledObject;
import java.util.*;

/**
 * EmsGmPcJh RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-10 07:00
 * 类描述
 * 修订历史：
 * 日期：2021-09-10
 * 作者：generator
 * 参考：
 * 描述：EmsGmPcJh RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/emsgmpcjhs")
public class EmsGmPcJhController extends BaseRESTfulController {
    private static  final  String AT2005 = "G-G1-";
    private static  final  String AT2006 = "G-G2-";
    private static  final  String AT2004 = "G-L1-";
    private static  final  String AT2007 = "G-X1-";

    @Autowired
    IEmsGmPcJhService emsGmPcJhService;
    @Autowired
    EmsGmPcJhMapper emsGmPcJhMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsgmpcjh:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsGmPcJh> list = emsGmPcJhService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsgmpcjh:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsGmPcJh> list = emsGmPcJhService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据EmsGmPcJh对象创建GM计划")
    @ApiImplicitParam(name = "emsGmPcJh", value = "详细实体emsGmPcJh", required = true, dataType = "EmsGmPcJh")
    //@RequiresPermissions("emsgmpcjh:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody EmsGmPcJh model){
        String userId = JwtUtil.getUseridByToken();
        String yyyymmdd = DateUtils.dateStr(model.getJhTime(), "yyyyMMdd");
        model.setStartTime(yyyymmdd);
        model.setType(this.getType(model));
        String maxid = emsGmPcJhService.getMaxid(model);
        model.setId(maxid);
        model.setKxfWeight(model.getPlanWeight());
        model.setYxfWeight(new BigDecimal("0"));
        model.setCreateTime(new Date());
        model.setCreateMan(userId);
        EmsGmPcJh emsGmPcJh = emsGmPcJhService.add(model);
        return success(emsGmPcJh);
    }

    @ApiOperation(value="创建", notes="根据EmsGmPcJh对象创建GM计划")
    @ApiImplicitParam(name = "emsGmPcJh", value = "详细实体emsGmPcJh", required = true, dataType = "EmsGmPcJh")
    //@RequiresPermissions("emsgmpcjh:create")
    @PostMapping(value = "/addNbJH")
    public RESTfulResult addNbJH(@RequestBody EmsGmPcJh model){
        String userId = JwtUtil.getUseridByToken();
        String yyyymmdd = DateUtils.dateStr(model.getJhTime(), "yyyyMMdd");
        model.setStartTime(yyyymmdd);
        model.setType(this.getNbJH(model));
        String maxid = emsGmPcJhService.getMaxid(model);
        model.setId(maxid);
        model.setPlanWeight(model.getPlanWeight() == null ? new BigDecimal("0"): model.getPlanWeight());
        model.setKxfWeight(model.getPlanWeight() == null ? new BigDecimal("0"): model.getPlanWeight());
        model.setYxfWeight(new BigDecimal("0"));
        model.setCreateTime(new Date());
        model.setState("1");
        model.setCreateMan(userId);
        EmsGmPcJh emsGmPcJh = emsGmPcJhService.add(model);
        return success(emsGmPcJh);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("emsgmpcjh:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        EmsGmPcJh emsGmPcJh = emsGmPcJhService.getById(id);
        return success(emsGmPcJh);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsGmPcJh信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "emsGmPcJh", value = "详细实体emsGmPcJh", required = true, dataType = "EmsGmPcJh")
    })
    //@RequiresPermissions("emsgmpcjh:update")
    @PutMapping(value = "/batchupdate", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@RequestBody EmsGmPcJh[] models){
        String userId = JwtUtil.getUseridByToken();
        for (EmsGmPcJh model : models) {
            EmsGmPcJh emsGmPcJh = this.emsGmPcJhMapper.selectByPrimaryKey(model.getId());
            if(emsGmPcJh.getState().equals("2")) {
                return failed(null,"操作失败，编号为"+emsGmPcJh.getId()+"已经接收");
            }
            if (model.getState().equals("1")) {
                return failed(model, "计划号为:" + model.getId() + "已下发无法做修改操作,请取消下发");
            }
            model.setYxfWeight(new BigDecimal("0"));
            model.setKxfWeight(model.getPlanWeight());
            model.setUpdateMan(userId);
            model.setUpdateTime(new Date());
            emsGmPcJhMapper.updateByPrimaryKey(model);
        }
        return success();
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("emsgmpcjh:delete")
    @DeleteMapping(value = "/delete",produces  = "application/json;charset=UTF-8")//String
    public RESTfulResult delete(@RequestBody EmsGmPcJh[] models){
        for (EmsGmPcJh model : models) {
            EmsGmPcJh emsGmPcJh = this.emsGmPcJhMapper.selectByPrimaryKey(model.getId());
            if(emsGmPcJh.getState().equals("2")) {
                return failed(null,"操作失败，编号为"+emsGmPcJh.getId()+"已经接收");
            }
            if (model.getState().equals("1")) {
                return failed(model,"计划号为:"+model.getId()+"已下发无法做删除操作,请取消下发");
            }
            emsGmPcJhMapper.deleteByPrimaryKey(model.getId());
        }
        return success();
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsGmPcJh信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "emsGmPcJh", value = "详细实体emsGmPcJh", required = true, dataType = "EmsGmPcJh")
    })
    //@RequiresPermissions("emsgmpcjh:update")
    @PutMapping(value = "/updatestate", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updatestate(@RequestBody EmsGmPcJh[] models){
        String userId = JwtUtil.getUseridByToken();
        for (EmsGmPcJh model : models) {
            EmsGmPcJh emsGmPcJh = this.emsGmPcJhMapper.selectByPrimaryKey(model.getId());
            if(emsGmPcJh.getState().equals("2")) {
                return failed(null,"操作失败，编号为"+emsGmPcJh.getId()+"已经接收");
            }
            model.setYxfWeight(new BigDecimal("0"));
            model.setKxfWeight(model.getPlanWeight());
            model.setUpdateTime(new Date());
            model.setUpdateMan(userId);
            emsGmPcJhService.updateState(model);
        }
        return success();
    }
    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @GetMapping("/getGmDates")
    public RESTfulResult getGmDates(@RequestParam HashMap<String,Object> parmas,Integer pageNum,Integer pageSize){
        if(parmas.get("workprocType") != null && !parmas.get("workprocType").toString().isEmpty()){
            String workprocType = parmas.get("workprocType").toString();
            if(!workprocType.startsWith("'")){
                workprocType = "'" + workprocType.replaceAll(",", "','").replaceAll("，", "','") + "'";
            }
            parmas.put("workprocType", workprocType);
        }
        PageList<Map<String, Object>> gmPcJhDataForPage = emsGmPcJhService.getGmPcJhDataForPage(parmas, pageNum, pageSize);
        return success(gmPcJhDataForPage);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsGmPcJh信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "emsGmPcJh", value = "详细实体emsGmPcJh", required = true, dataType = "EmsGmPcJh")
    })
    //@RequiresPermissions("emsgmpcjh:update")
    @PutMapping(value = "/batchcopy", produces  = "application/json;charset=UTF-8")
    public RESTfulResult batchcopy(@RequestBody EmsGmPcJh[] models){
        String userId = JwtUtil.getUseridByToken();
        for (EmsGmPcJh model : models) {
            String yyyymmdd = DateUtils.dateStr(model.getJhTime(), "yyyyMMdd");
            model.setStartTime(yyyymmdd);
            model.setType(this.getType(model));
            String maxid = emsGmPcJhService.getMaxid(model);
            model.setId(maxid);
            model.setState("0");
            model.setKxfWeight(model.getPlanWeight());
            model.setYxfWeight(new BigDecimal("0"));
            model.setUpdateTime(null);
            model.setUpdateMan(null);
            model.setCreateTime(new Date());
            model.setCreateMan(userId);
            emsGmPcJhService.add(model);
        }
        return success();
    }

    public String getType (EmsGmPcJh emsGmPcJh){
        if (emsGmPcJh.getWorkprocType().equals("AT2004")){
            return AT2004;
        }
        if(emsGmPcJh.getWorkprocType().equals("AT2005")){
            return AT2005;
        }
        if (emsGmPcJh.getWorkprocType().equals("AT2006")){
            return AT2006;
        }
        if (emsGmPcJh.getWorkprocType().equals("AT2007")) {
            return  AT2007;
        }
        return null;
    }
    public String getNbJH (EmsGmPcJh emsGmPcJh){
        if (emsGmPcJh.getWorkprocType().equals("AT2004")){
            return "N-L1-";
        }
        if(emsGmPcJh.getWorkprocType().equals("AT2005")){
            return "N-G1-";
        }
        if (emsGmPcJh.getWorkprocType().equals("AT2006")){
            return "N-G2-";
        }
        if (emsGmPcJh.getWorkprocType().equals("AT2007")) {
            return  "N-X1-";
        }
        return null;
    }
}
